/************************************************************************
 *									*
 *		nr^Q@IC[UT|[gVXe		*
 *			ob|mds^Q				*
 *									*
 *				: ̔͏			*
 *		t@C	: sales.c				*
 *		쐬		: s.aizawa				*
 *									*
 ************************************************************************/

#include "pcnet.h"
#include <string.h>

/*--------------------------------------*/
/*		֐		*/
/*--------------------------------------*/
static	VOID	SetSalesData(HWND);
static	VOID	WriteSalesData(HWND, BOOL);
static	BOOL	CreateSalesDBF(VOID);
static	BOOL	UseSalesIndex(BOOL);

/*--------------------------------------*/
/*		ϐ		*/
/*--------------------------------------*/
static	SALESDBF	salesBuf;	/* ̔t@Cobt@ */
static	SALESDBF	salesBuf2;	/* ̔t@Cobt@Q */
static	ENTRY_TBL	entryTbl[6] = {	/* ͏e[u */
	{ET_STRINGFIELD, IDD_SALE_SExxxN, 40, salesBuf.sexxxn},
	{ET_STRINGFIELD, IDD_SALE_SERIAL, 16, salesBuf.serial},
	{ET_STRINGFIELD, IDD_SALE_DATE,    8, salesBuf.date},
	{ET_STRINGFIELD, IDD_SALE_PRICE,  12, salesBuf.price},
	{ET_STRINGFIELD, IDD_SALE_SHOP,   40, salesBuf.shop},
	{ET_STRINGFIELD, IDD_SALE_BIKOU,  40, salesBuf.bikou}
};
static	CHAR	userID[8];		/* [Uhc */
static	SHORT	page;			/* Jgy[W */
static	SHORT	nPage;			/* y[W */

/*=======================================================================
 |
 |		̔̓_CAOvV[W
 |
 |	MRESULT CALLBACK SalesDlg(hwnd, msg, mp1, mp2)
 |
 |		HWND	hwnd;		EBhEnh
 |		USHORT	msg;		bZ[Wʎq
 |		MPARAM	mp1;		bZ[Wp[^P
 |		MPARAM	mp2;		bZ[Wp[^Q
 |
 =======================================================================*/
MRESULT CALLBACK SalesDlg(HWND hwnd, USHORT msg, MPARAM mp1, MPARAM mp2)
{
	switch (msg) {
	case WM_INITDLG:
		memcpy(userID, (CHAR *)mp2, 8);
		nPage = (SHORT)DBCount(salesDBp, userID, 8, indexSales);
		if (nPage == 0)
			page = 0;
		else
			page = nPage - 1;
		SetSalesData(hwnd);
		CenterDlgBox(hwnd);
		break;
	case WM_COMMAND:
		switch(SHORT1FROMMP(mp1)) {
		case DID_OK:
			WriteSalesData(hwnd, FALSE);
			break;
		case DID_CANCEL:
			break;
		case IDD_CMD_DELETE:
			if (WinMessageBox(HWND_DESKTOP, hwnd,
					"폜܂B낵łH",
					"m@F", ID_MB,
					MB_YESNO | MB_ICONQUESTION |
					MB_APPLMODAL) == MBID_YES) {
				DBDelete2(salesDBp);
				nPage--;
				if (page == nPage && page != 0)
					page--;
				SetSalesData(hwnd);
			}
			return(0);
		case IDD_CMD_PPAGE:
			WriteSalesData(hwnd, TRUE);
			if (page > 0) {
				page--;
				SetSalesData(hwnd);
			}
			return(0);
		case IDD_CMD_NPAGE:
			WriteSalesData(hwnd, TRUE);
			if (page < nPage) {
				page++;
				SetSalesData(hwnd);
			}
			return(0);
		}
	}
	return(WinDefDlgProc(hwnd, msg, mp1, mp2));
}

/*=======================================================================
 |
 |		̔_CAOɕ\
 |
 |	VOID	SetSalesData(hwnd)
 |
 |		HWND	hwnd;		EBhEnh
 |
 =======================================================================*/
static	VOID	SetSalesData(HWND hwnd)
{
	CHAR	strBuf[40];

	if (page == nPage) {
		memset(&salesBuf, ' ', sizeof(salesBuf));
		memcpy(salesBuf.userID, userID, 8);
	} else {
		DBSearch(salesDBp, userID, 8, indexSales);
		DBSkip(salesDBp, (long)page);
		DBRead(salesDBp, &salesBuf);
	}
	salesBuf2 = salesBuf;

	SetEntryData(hwnd, entryTbl, sizeof(entryTbl) / sizeof(ENTRY_TBL));

	if (page == nPage)
		sprintf(strBuf, "̔iVKo^j");
	else
		sprintf(strBuf, "̔ (%d/%d)", page+1, nPage);
	WinSetWindowText(hwnd, strBuf);

	WinEnableWindow(WinWindowFromID(hwnd, IDD_CMD_DELETE), page != nPage);
	WinEnableWindow(WinWindowFromID(hwnd, IDD_CMD_PPAGE), page != 0);
	WinEnableWindow(WinWindowFromID(hwnd, IDD_CMD_NPAGE), page != nPage);
}

/*=======================================================================
 |
 |		_CAO̔oAt@Cɏ
 |
 |	VOID	WriteSalesData(hwnd, fCheck)
 |
 |		HWND	hwnd;		EBhEnh
 |		BOOL	fCheck;		XVmFLtO
 |
 =======================================================================*/
static	VOID	WriteSalesData(HWND hwnd, BOOL fCheck)
{
	GetEntryData(hwnd, entryTbl, sizeof(entryTbl) / sizeof(ENTRY_TBL));

	if (memcmp(&salesBuf, &salesBuf2, sizeof(SALESDBF)) == 0)
		return;

	if (fCheck) {
		if (WinMessageBox(HWND_DESKTOP, hwnd,
				"XV܂H",
				"m@F", ID_MB,
				MB_YESNO | MB_ICONQUESTION |
				MB_APPLMODAL) != MBID_YES) {
			return;
		}
	}

	if (page == nPage) {
		DBStore(salesDBp, &salesBuf);
		nPage++;
	} else {
		DBUpdate(salesDBp, &salesBuf);
	}
}

/*=======================================================================
 |
 |		̔t@CI[v
 |
 |	BOOL	OpenSalesDBF(fIndexCreate)
 |
 |		BOOL	fIndexCreate;	CfbNXt@C쐬tO
 |
 |		BOOL	Ԓl		TRUE F
 |					FALSEFI[vsi~j
 |
 =======================================================================*/
BOOL	OpenSalesDBF(BOOL fIndexCreate)
{
	if ((salesDBp = DBOpen(fnSALESDBF)) == NULL) {
		if (WinMessageBox(HWND_DESKTOP, hwndMain,
				"VKɍ쐬܂H",
				"̔t@C܂I", ID_MB,
				MB_YESNO | MB_ICONQUESTION | MB_APPLMODAL
				) == MBID_YES)
			return(CreateSalesDBF());
		else
			return(FALSE);
	} else {
		if (DBCheckSize(salesDBp))
			fIndexCreate = TRUE;
	}

	if (UseSalesIndex(fIndexCreate) == FALSE) {
		DBClose(salesDBp);
		return(FALSE);
	}

	return(TRUE);
}

/*=======================================================================
 |
 |		̔t@CVK쐬
 |
 |	BOOL	CreateSalesDBF()
 |
 |		BOOL	Ԓl		TRUE F
 |					FALSEF쐬s
 |
 =======================================================================*/
static	BOOL	CreateSalesDBF(VOID)
{
	static	DBF_I	fieldData[] = {
		{"[Uhc", 'C',  8, 0},
		{"i",     'C', 40, 0},
		{"VANo", 'C', 16, 0},
		{"wt",   'C',  8, 0},
		{"wi",   'C', 12, 0},
		{"̔X",     'C', 40, 0},
		{"l",       'C', 40, 0}
	};

	if ((salesDBp = DBCreate(fnSALESDBF, fieldData,
				sizeof(fieldData)/sizeof(DBF_I))) == NULL) {
		WinMessageBox(HWND_DESKTOP, hwndMain,
				"t@C쐬ł܂łB",
				"̔t@CANZXG[I",
				ID_MB,
				MB_OK | MB_ICONEXCLAMATION | MB_APPLMODAL);
		return(FALSE);
	}

	if (UseSalesIndex(TRUE) == FALSE) {
		DBClose(salesDBp);
		return(FALSE);
	}

	return(TRUE);
}

/*=======================================================================
 |
 |		̔t@C̃CfbNXt@CI[v^쐬
 |
 |	BOOL	UseSalesIndex(fCreate)
 |
 |		BOOL	fCreate;	쐬tO
 |
 |		BOOL	Ԓl		TRUE F
 |					FALSEF쐬s
 |
 =======================================================================*/
static	BOOL	UseSalesIndex(BOOL fCreate)
{
	if (fCreate || (indexSales = DBIndex(salesDBp, fnSALESNDX)) == 0) {
		if ((indexSales = DBIdxCreate(salesDBp, fnSALESNDX,
					"[Uhc+wt", 0)) == 0) {
			WinMessageBox(HWND_DESKTOP, hwndMain,
				"CfbNXt@C쐬ł܂łB",
				"̔t@CANZXG[I",
				ID_MB,
				MB_OK | MB_ICONEXCLAMATION | MB_APPLMODAL);
			return(FALSE);
		}
	}
	return(TRUE);
}
